// Name	::	Server Shutdown
// ================
// Made by	::	McTwist
// Date	::	10-03-10
// Info	::	Only minutes left until server shutdown.
// License	::	Free to use
// ================

$ShutdownSchedule = 0;

// Shut down!
function ServerCmdShutdown(%client, %time)
{
	// Avoid other people
	if (%client.bl_id !$= getNumKeyID())
		return;
	
	if ($ShutdownSchedule)
		return;
	
	%time = mFloor(%time);
	if (%time <= 0)
		%time = 1;
	
	$ShutdownSchedule = schedule(0, 0, "scheduleShutdown", %time);
	if (!(%time % 10 == 0 || %time == 5 || %time == 1))
		messageBoth("\c2Server shutdown in \c3" @ %time @ "\c2 minute" @ ((%time != 1) ? "s" : "") @ ".");
}

// We're having some problem here
function ServerCmdAbortShutdown(%client)
{
	// Avoid other people
	if (%client.bl_id !$= getNumKeyID())
		return;
	
	if (!$ShutdownSchedule)
		return;
	
	Cancel($ShutdownSchedule);
	$ShutdownSchedule = 0;
	messageBoth("\c2Shutdown terminated");
}

// Duplicate for security
function ServerCmdAbortSh(%client)
{
	ServerCmdAbortShutdown(%client);
}

// Schedule minutes
function scheduleShutdown(%time)
{
	if ($ShutdownSchedule)
		Cancel($ShutdownSchedule);
	
	// Each 10 minutes, five and one minute left
	if (%time % 10 == 0 || %time == 5 || %time == 1)
		messageBoth("\c2Server shutdown in \c3" @ %time @ "\c2 minute" @ ((%time != 1) ? "s" : "") @ ".");
	// Go over to seconds
	if (%time == 1)
	{
		$ShutdownSchedule = schedule(50000, 0, "scheduleShutdownSec", 10);
		return;
	}
	%time--;

	$ShutdownSchedule = schedule(60000, 0, "scheduleShutdown", %time);
}

// Schedule seconds
function scheduleShutdownSec(%time)
{
	if ($ShutdownSchedule)
		Cancel($ShutdownSchedule);
	
	if (%time <= 0)
	{
		// Throw out players
		Shutdown();
		// Shutdown
		Quit();
	}
	else
	{
		messageBoth("\c2Server shutdown in \c3" @ %time @ "\c2 second" @ ((%time != 1) ? "s" : "") @ ".");
		%time--;
	
		$ShutdownSchedule = schedule(1000, 0, "scheduleShutdownSec", %time);
	}
}

function messageBoth(%text)
{
	messageAll('', %text);
	%a = ClientGroup.getCount();
	for (%i = 0; %i < %a; %i++)
		commandToClient(ClientGroup.getObject(%i), 'centerPrint', %text, 2);
}